<?php /*
Plugin Name: Front2Back
Version: 1.7.d
Description: Postcards back display if there is. / Verso d'une carte.
Plugin URI: http://phpwebgallery.net/ext/extension_view.php?eid=183
Author: VDigital (PhpWebGallery team)
Author URI: http://www.phpwebgallery.net
*/

/* Synopsis
1 - If same name file exists in ./thumbnail/verso/ or ...
2 - A link is displayed
3 - OnMouseOver Front2Back replace the original picture

Localisation of Front2Back, just add:
$lang['Front2Back'] = 'See back';
in your ./language/xxxx/local.lang.php

Requirements/recommendations:
1 - Backsize = Frontsize
2 - Profile displayed sizes are Null or > Backsided pictures sizes
3 - Metadata are synchronized

*/
/*
History
  2007-11-07 Add -r to back filenames if your picture are portrait in one side
             and landscape in the other one.  
  2007-10-10 Additional and optionnal parameters
     $conf['Front2Back_path'] real path if you want them outside ./galleries/
       Warning: if F2B_path is set then directory tree will not reminded !
     $conf['Front2Back_parent'] can be set to 'thumbnail/' or 'pwg_high/'
     
  2007-10-08 Conflict with PY GVideo solved 
     (render_element_content usage error: No residual impact)
  2007-10-07 First release
*/

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
add_event_handler('render_element_content', 
    array('Front2Back', 'Front2Back_css') );

class Front2Back
{
  function Front2Back_css($content)
  {
    global $template;
    $link = '<link rel="stylesheet" type="text/css" '
             . 'href="' . PHPWG_PLUGINS_PATH . 'Front2Back/back.css">';
    $template->assign_block_vars(
      'head_element',
       array(
         'CONTENT' => $link,
       )
     );
    add_event_handler('loc_end_picture', 
      array('Front2Back', 'Front2Back_swap'));
    return $content;
  }
  function Front2Back_swap()
  {
    global $picture, $template, $lang, $user, $conf;
    /* Default values */
    if (!isset($lang['Front2Back'])) { $lang['Front2Back'] = 'See back'; }
    if (!isset($conf['Front2Back_dir'])) { $conf['Front2Back_dir'] = 'verso/'; }
    if (!isset($conf['Front2Back_vshift'])) { $conf['Front2Back_vshift']= 25;}
    if (!isset($conf['Front2Back_hshift'])) { $conf['Front2Back_hshift']= -23;}
    if (!isset($conf['Front2Back_parent'])) { 
      $conf['Front2Back_parent']= 'thumbnail/';
    }
    if (!isset($conf['Front2Back_path'])) {
      $conf['Front2Back_inside']= true;
    }
    else { $conf['Front2Back_inside']= false; }    
    /* Update template */
    $template->loadfile('picture');
    
    $template->uncompiled_code['picture'] = 
      str_replace('<!-- BEGIN legend -->', 
      '<!-- BEGIN verso -->
<br />
<a class="reverse" href="#">
  {lang:Front2Back}
  <span style="top: -{verso.VSHIFT_IMG}px; left: -{verso.HSHIFT_IMG}px;">
    <img src="{verso.VERSO_URL}"
          style="width:{verso.WIDTH_IMG}px;height:{verso.HEIGHT_IMG}px;"
          alt="Verso" />
    <br />
    <!--
    Dynamic Drive
    <img src="http://www.dynamicdrive.com/cssexamples/media/dynamicdrive.gif" />
    -->
  </span>
</a>
<!-- END verso -->
<!-- BEGIN legend -->', 
      $template->uncompiled_code['picture']);
    
    /* Build reversal parms and filename */ 
    if ( $conf['Front2Back_inside'] ) {
      $verso = substr( $picture['current']['path'],
                0, strrpos( $picture['current']['path'], '/' )+1 )
                . $conf['Front2Back_parent'] . $conf['Front2Back_dir'];
    }
    else {  /* example: 
      $conf['Front2Back_path'] = PHPWG_ROOT_PATH;
      $conf['Front2Back_parent'] = 'front2back/';
      $conf['Front2Back_dir'] = '';
      */
      $verso = $conf['Front2Back_path']
                . $conf['Front2Back_parent'] . $conf['Front2Back_dir'];
    }
    $verso.= $picture['current']['file'];
    $height = @$picture['current']['scaled_height'];
    $width = @$picture['current']['scaled_width'];
    $shift_left = (int) ($width / 2) + $conf['Front2Back_hshift'];
    $shift_up = $height  + $conf['Front2Back_vshift']; 
    $rotat = substr($verso,0,-4).'-r'.substr($verso,-4); // extension .jpg 4car.
    /* Is there a file ? */ 
    if (is_file($verso)) {
      $template->assign_block_vars(
        'verso',
         array(
           'VERSO_URL' => $verso,
           'WIDTH_IMG' => $width,
           'HEIGHT_IMG' => $height,
           'HSHIFT_IMG' => $shift_left,
           'VSHIFT_IMG' => $shift_up,
         )
       );
    }
    elseif (is_file($rotat)) {           /* Is there a rotated file ? */ 
      $shift_left = (int) ($height / 2) + $conf['Front2Back_hshift'];    
      $template->assign_block_vars(
        'verso',
         array(
           'VERSO_URL' => $rotat,
           'WIDTH_IMG' => $height, /* Switch width/height */
           'HEIGHT_IMG' => $width, /*   ""        ""      */
           'HSHIFT_IMG' => $shift_left,
           'VSHIFT_IMG' => $shift_up,
         )
       ); 
    } 
  }  
}
?>
